// MemoListCtrl.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "MemoListCtrl.h"

//-----------------------------------------------------------------------------
// by cscho

// CMemoListCtrl
IMPLEMENT_DYNAMIC(CMemoListCtrl, CListCtrl)

CMemoListCtrl::CMemoListCtrl()
{
	CFont* curWinFont = &g_ftDefault8PT;

	LOGFONT logFont;
	curWinFont->GetLogFont(&logFont);
	logFont.lfUnderline = TRUE;
	m_fntUnderlineTxt.CreateFontIndirect(&logFont);

	logFont.lfUnderline = FALSE;
	logFont.lfWeight = FW_NORMAL;
	m_fntNormalTxt.CreateFontIndirect(&logFont);

	m_nTrackItem = -1;
	m_nTrackSubItem = -1;
	m_rtTrackNew.SetRectEmpty();
	m_rtTrackOld.SetRectEmpty();

	m_nDownItem = -1;
	m_nDownSubItem = -1;
}

CMemoListCtrl::~CMemoListCtrl()
{
	ClearListType();

	m_fntUnderlineTxt.DeleteObject();
	m_fntNormalTxt.DeleteObject();
}

BEGIN_MESSAGE_MAP(CMemoListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_WM_MOUSEMOVE()
	ON_WM_CREATE()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

CString CMemoListCtrl::InsertCharToString(CString strOrigin, int nPos, TCHAR ch)
{
	CString strRet = _T("");
	TCHAR tchNow = _T('');
	CString strPrev = _T("");
	int nLen = strOrigin.GetLength();

	int nCount = 0;
	for (int i = nLen - 1; i >= 0; i--, nCount++)
	{
		if (nCount > 0 && (nCount % nPos == 0))
		{
			strPrev.Insert(0, ch);
		}

		tchNow = strOrigin.GetAt(i);
		strRet = tchNow;
		strRet += strPrev;

		strPrev = strRet;
	}

	return strRet;
}

int CMemoListCtrl::GetCheckedItem(CUIntArray* puiItem)
{
	if (!puiItem)
		return 0;

	int nCntItem = GetItemCount();
	for (int i = 0; i < nCntItem; i++)
	{
		if (GetCheck(i))
			puiItem->Add(i);
	}

	return puiItem->GetCount();
}

int CMemoListCtrl::GetColumns()
{
	return GetHeaderCtrl()->GetItemCount();
}

BOOL CMemoListCtrl::GetSubItemRect(int nItem, int nSubItem, int nArea, CRect& rect)
{
	ASSERT(nItem >= 0);
	ASSERT(nItem < GetItemCount());
	if ((nItem < 0) || nItem >= GetItemCount())
		return FALSE;

	ASSERT(nSubItem >= 0);
	ASSERT(nSubItem < GetColumns());
	if ((nSubItem < 0) || nSubItem >= GetColumns())
		return FALSE;

	BOOL bRC = CListCtrl::GetSubItemRect(nItem, nSubItem, nArea, rect);

	if (nSubItem == 0)
	{
		if (GetColumns() > 1)
		{
			CRect rect1(0, 0, 0, 0);
			bRC = GetSubItemRect(nItem, 1, LVIR_BOUNDS, rect1);
			rect.right = rect1.left;
		}
	}

	return bRC;
}

void CMemoListCtrl::UpdateSubItem(int nItem, int nSubItem)
{
	ASSERT(nItem >= 0);
	ASSERT(nItem < GetItemCount());
	if ((nItem < 0) || nItem >= GetItemCount())
		return;
	ASSERT(nSubItem >= 0);
	ASSERT(nSubItem < GetColumns());
	if ((nSubItem < 0) || nSubItem >= GetColumns())
		return;

	CRect rect(0, 0, 0, 0);
	if (nSubItem == -1)
	{
		GetItemRect(nItem, &rect, LVIR_BOUNDS);
	}
	else
	{
		GetSubItemRect(nItem, nSubItem, LVIR_BOUNDS, rect);

		RedrawWindow(&rect, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

		m_rtTrackOld = m_rtTrackNew;
		m_rtTrackNew = rect;
	}

	//InvalidateRect(&rect);
	//UpdateWindow();
}

void CMemoListCtrl::ClearListType()
{
	LIST_ITEM_TYPE* pLIT = NULL;
	std::vector<LIST_ITEM_TYPE*>::const_iterator iter = m_vecListItem.begin();
	for (; iter != m_vecListItem.end(); iter++)
	{
		pLIT = (LIST_ITEM_TYPE*)(*iter);
		if (!pLIT)
			continue;

		//-----------------------------------------------------------------------------
		// by cscho
		// ̹ ÷ ߰
		if (pLIT->pImg)
			delete pLIT->pImg;
		//-----------------------------------------------------------------------------

		delete pLIT;
	}
	m_vecListItem.clear();
}

//-----------------------------------------------------------------------------
// by cscho
// ̹ ÷ ߰
void CMemoListCtrl::AddListType(int nSubItem, _inner_item eType, CString strImgPath, UINT uiMsg, CWnd* pWndMaster)
{
	LIST_ITEM_TYPE* pLIT = new LIST_ITEM_TYPE;
	if (NULL == pLIT)
		return;

	memset(pLIT, 0, sizeof(LIST_ITEM_TYPE));

	pLIT->nSubItem = nSubItem;
	pLIT->eItemType = eType;
	if (!strImgPath.IsEmpty())
		pLIT->pImg = new Image(strImgPath);
	pLIT->uiMsg = uiMsg;
	pLIT->pWndMaster = pWndMaster;

	m_vecListItem.push_back(pLIT);
}
//-----------------------------------------------------------------------------
void CMemoListCtrl::GetHoverListItem(CPoint point, int& nItem, int& nSubItem)
{
	nItem = -1;
	nSubItem = -1;

	CRect rect(0, 0, 0, 0);

	for (int i = 0; i < GetItemCount(); i++)
	{
		if (GetItemRect(i, &rect, LVIR_BOUNDS))
		{
			if (rect.PtInRect(point))
			{
				nItem = i;
				break;
			}
		}
	}

	if (nItem == -1)
	{
	}
	else
	{
		int nColumns = 0;
		CHeaderCtrl* pHeader = GetHeaderCtrl();
		if (pHeader)
			nColumns = pHeader->GetItemCount();

		for (int i = 0; i < GetColumns(); i++)
		{
			GetSubItemRect(nItem, i, LVIR_BOUNDS, rect);
			if (rect.PtInRect(point))
			{
				nSubItem = i;
				break;
			}
		}

		if (nSubItem == -1)
		{
		}
		else
		{
		}
	}
}

// CMemoListCtrl ޽ óԴϴ.
int CMemoListCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CListCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

void CMemoListCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	CString strItem = _T(""), strMsg = _T("");

	SetCapture();

	int nDownItem = -1;
	int nDownSubItem = -1;

	GetHoverListItem(point, nDownItem, nDownSubItem);

	m_nDownItem = nDownItem;
	m_nDownSubItem = nDownSubItem;

	if (m_nDownItem != -1 && m_nDownSubItem != -1)
	{
		std::vector<LIST_ITEM_TYPE*>::const_iterator iter = m_vecListItem.begin();
		for (; iter != m_vecListItem.end(); iter++)
		{
			int nVecSubItem = (*iter)->nSubItem;
			if (m_nDownSubItem != nVecSubItem)
				continue;

			int nListType = (*iter)->eItemType;
			if (nListType != LIST_TYPE_TRACKTEXT)
				continue;

			return;
		}
	}

	CListCtrl::OnLButtonDown(nFlags, point);
}

void CMemoListCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	CString strItem = _T(""), strMsg = _T("");

	ReleaseCapture();

	int nDownItem = -1;
	int nDownSubItem = -1;

	GetHoverListItem(point, nDownItem, nDownSubItem);

	if (nDownItem == m_nDownItem && nDownSubItem == m_nDownSubItem)
	{
		strItem = GetItemText(m_nDownItem, m_nDownSubItem);
		if (!strItem.IsEmpty())
		{
			std::vector<LIST_ITEM_TYPE*>::const_iterator iter = m_vecListItem.begin();
			for (; iter != m_vecListItem.end(); iter++)
			{
				int nVecSubItem = (*iter)->nSubItem;
				if (m_nDownSubItem != nVecSubItem)
					continue;

				int nListType = (*iter)->eItemType;
				if (nListType != LIST_TYPE_TRACKTEXT)
					continue;

				CWnd* pWndMaster = (*iter)->pWndMaster;
				UINT uiMsg = (*iter)->uiMsg;
				if (pWndMaster && pWndMaster->GetSafeHwnd() && uiMsg > 0)
					pWndMaster->SendMessage(uiMsg, (WPARAM)0, (LPARAM)m_nDownItem);
				return;
			}
		}
	}

	m_nDownItem = -1;
	m_nDownSubItem = -1;

	CListCtrl::OnLButtonUp(nFlags, point);
}

void CMemoListCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	CString strItem = _T(""), strMsg = _T("");
	int nItem = -1, nSubItem = -1;
	CRect rect(0, 0, 0, 0);

	int nTrackItem = -1;
	int nTrackSubItem = -1;

	GetHoverListItem(point, nItem, nSubItem);

	if (nItem != -1 && nSubItem != -1)
	{
		strItem = GetItemText(nItem, nSubItem);
		if (!strItem.IsEmpty())
		{
			std::vector<LIST_ITEM_TYPE*>::const_iterator iter = m_vecListItem.begin();
			for (; iter != m_vecListItem.end(); iter++)
			{
				int nSubItemVec = (*iter)->nSubItem;
				int nListType = (*iter)->eItemType;
				if (nSubItemVec == nSubItem && nListType == LIST_TYPE_TRACKTEXT)
				{
					nTrackItem = nItem;
					nTrackSubItem = nSubItem;

					if ((m_nTrackItem != nTrackItem) || (m_nTrackSubItem != nTrackSubItem))
					{
						m_nTrackItem = nTrackItem;
						m_nTrackSubItem = nTrackSubItem;

						UpdateSubItem(nItem, nSubItem);

						RedrawWindow(&m_rtTrackOld, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

						return;
					}
				}
			}
		}
	}

	if ((m_nTrackItem != -1 && m_nTrackSubItem != -1) && (nTrackItem == -1 && nTrackSubItem == -1))
	{
		m_nTrackItem = -1;
		m_nTrackSubItem = -1;

		RedrawWindow(&m_rtTrackNew, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		RedrawWindow(&m_rtTrackOld, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CListCtrl::OnMouseMove(nFlags, point);
}

void CMemoListCtrl::OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult)
{
	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>(pNMHDR);

	int nItem = static_cast<int>(pLVCD->nmcd.dwItemSpec);
	int nSubItem = pLVCD->iSubItem;

	CString strItem = _T(""), strMsg = _T("");

	*pResult = CDRF_DODEFAULT;

	if (pLVCD->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		*pResult = CDRF_NOTIFYSUBITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == (CDDS_ITEMPREPAINT | CDDS_SUBITEM))
	{
		*pResult = CDRF_DODEFAULT;

		UINT nFormat = DT_VCENTER | DT_SINGLELINE;

		CHeaderCtrl* pHeader = GetHeaderCtrl();
		if (pHeader)
		{
			HDITEM hditem;
			hditem.mask = HDI_FORMAT;
			pHeader->GetItem(nSubItem, &hditem);
			int nFmt = hditem.fmt & HDF_JUSTIFYMASK;			
			if (nFmt == HDF_CENTER)
				nFormat |= DT_CENTER;
			else if (nFmt == HDF_LEFT)
				nFormat |= DT_LEFT;
			else
				nFormat |= DT_RIGHT;

			strItem = GetItemText(nItem, nSubItem);
		}

		CRect rt(0, 0, 0, 0);
		GetSubItemRect(nItem, nSubItem, LVIR_BOUNDS, rt);

		CDC* pDC = CDC::FromHandle(pLVCD->nmcd.hdc);
		if (!pDC)
			return;

		std::vector<LIST_ITEM_TYPE*>::const_iterator iter = m_vecListItem.begin();
		for (; iter != m_vecListItem.end(); iter++)
		{
			int nVecSubItem = (*iter)->nSubItem;
			if (nSubItem != nVecSubItem)
				continue;

			int nListType = (*iter)->eItemType;
			switch (nListType)
			{
			case LIST_TYPE_NORMAL_TEXT:
				{
					*pResult = CDRF_DODEFAULT;
				}
				break;
				//-----------------------------------------------------------------------------
				// by cscho
				// ̹ ÷ ߰
			case LIST_TYPE_IMAGE:
				{
					Graphics graphic(pDC->m_hDC);
					graphic.SetPixelOffsetMode(PixelOffsetModeHalf);
					graphic.SetInterpolationMode(InterpolationModeNearestNeighbor);
					if ((*iter)->pImg)
					{
						Image* pImage = (*iter)->pImg;
						int nIWidth = pImage->GetWidth();
						int nIHeight = pImage->GetHeight();
						int nDWidth = nIWidth;
						if (nIWidth > rt.Width())
							nDWidth = rt.Width();
						int nDHeight = nIHeight;
						if (nIHeight > rt.Height())
							nDHeight = rt.Height();
						int nDX = rt.left;
						if (nIWidth < rt.Width())
							nDX = rt.left + ((rt.Width() - nIWidth) / 2);
						int nDY = rt.top;
						if (nIHeight < rt.Height())
							nDY = rt.top + ((rt.Height() - nIHeight) / 2);
						graphic.DrawImage((*iter)->pImg, nDX, nDY, nDWidth, nDHeight);
					}

					*pResult = CDRF_SKIPDEFAULT;
				}
				break;
				//-----------------------------------------------------------------------------
			case LIST_TYPE_NONHIGHLIGHT_TEXT:
			case LIST_TYPE_TRACKTEXT:
				{
					pDC->SetBkMode(TRANSPARENT);

					COLORREF crText = RGB(0, 0, 0);
					COLORREF crBack = RGB(255, 255, 255);

					CFont* pOldFont = NULL;
					if (nListType == LIST_TYPE_TRACKTEXT)
					{
						crText = RGB(65, 70, 213);
						if (nItem == m_nTrackItem && nSubItem == m_nTrackSubItem)
							pOldFont = pDC->SelectObject(&m_fntUnderlineTxt);
						else
							pOldFont = pDC->SelectObject(&m_fntNormalTxt);
					}
					pDC->SetTextColor(crText);
					pDC->SetBkColor(crBack);

					pDC->FillSolidRect(&rt, crBack);
					pDC->DrawText(strItem, &rt, nFormat);

					if (pOldFont)
						pDC->SelectObject(pOldFont);

					*pResult = CDRF_SKIPDEFAULT;
				}
				break;
			case LIST_TYPE_PROGRESS:
				{
					LIST_ITEM_PROGRESS* pLIP = (LIST_ITEM_PROGRESS*)pLVCD->nmcd.lItemlParam;
					if (!pLIP)
						return;

					DWORD dwTotalLen = pLIP->dwLenTotal;
					switch (pLIP->eState)
					{
					case PROGRESS_READY:
					case PROGRESS_COMPLETE:
						{
							*pResult = CDRF_DODEFAULT;
						}
						break;
					case PROGRESS_DO:
						{
							*pResult = CDRF_SKIPDEFAULT;

							DWORD dwLen = pLIP->dwLenProgress;

							int nPct = (dwLen * 100) / dwTotalLen;

							pDC->SetBkMode(TRANSPARENT);
							pDC->SetTextColor(RGB(255, 255, 255));
							pDC->SetBkColor(RGB(0, 128, 255));
							strItem.Format(_T("%d %%"), nPct);

							pDC->FillSolidRect(&rt, RGB(192, 225, 255));

							CRect rtPct = rt;
							rtPct.right = rt.left + ((nPct * rt.Width()) / 100);
							pDC->FillSolidRect(&rtPct, RGB(0, 128, 255));
							pDC->DrawText(strItem, &rt, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
						}
						break;
					}
				}
				break;
			}
			break;
		}
	}
}

BOOL CMemoListCtrl::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if (m_nTrackItem != -1 && m_nTrackSubItem != -1)
	{
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
		return TRUE;
	}
	else
		::SetCursor(LoadCursor(NULL, IDC_ARROW));

	return CListCtrl::OnSetCursor(pWnd, nHitTest, message);
}
//-----------------------------------------------------------------------------
